---
output:
  html_document: default
  pdf_document: default
---

# Module 5: Open Research Software and Open Source

## Содержание

 - [Введение](#Введение)
 - [Что такое Открытое программное обеспечение](#Об_ОПО)
 - [Принципы ОПО](#Принципы)
 - [Сообщество Open Source и его управление](#ОПО_сообщество)
 - [Платформы и инструменты ОПО](#Платформы)
 - [ОПО для исследований](#Исследования)
 - [Первые шаги в ОПО - FAQ](#FAQ)
 - [Создание ПО для многократного пользования](#Re-use)
 - [Лицензирование ОПО](#Лицензирование)
 - [Цитирование ПО](#Цитирование)
 - [Работа с GitHub и Zenodo](#GitHub_Zenodo)
 - [Совместная работа на основе Open Source](#Коллаборации)
 - [Что дальше](#Продолжение_ОПО)

**ВНИМАНИЕ** аудиоверсия доступна для загрузки по ссылке [Soundcloud](https://soundcloud.com/open-science-mooc/module-5-open-source-and-open-research-software) и [YouTube](https://www.youtube.com/watch?v=BHrOEmKk5zM).

## Введение <a name="Введение"></a>

Добро пожаловать в **Модуль 5** МООКа по Open Science: **Открытое программное обеспечение и Open Source**.

Этот модуль был разработан [в открытом доступе](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source) международной командой [Open Source afficianados](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/README.md#development-team-). Все, что вы здесь видите - результат работы многих людей, работающих вместе на открытой платформе. Здесь вы сможете найти видео, инфографику, литературу и практические задания.

Напомним, что вы всегда можете принять участие в открытом [**чате**](https://osmooc.herokuapp.com/) на платформе Slack. Пожалуйста, расскажите о себе под хештэгом #module5opensource, расскажите нам, чем вы занимаетесь и что вас сюда привело.

### Для кого этот модуль?

Этот модуль подойдет тем, кто занимается вычислительной работой (как студентам, так и выпускникам), машинным обучением и анализом данных. По большому счету, модуль будет полезен каждому, кто использует компьютер для работы.

> "Статья о вычислительном результате это реклама, а не стипендия. Настоящая стипендия - это полная программная среда, код и данные, которые дали результат" - Д. Букэйт и Д. Л. Донохо, 1995.

На программном обеспечении и технологиях зиждется большая часть современных исследований, которые практически неизбежно связаны с вычислениями - поисковые машины, платформы для нетворкинга, аналитическое программное обеспечение и публикация работ в вебе. Ввиду тесной связи исследований с технологиями растет потребность в более изощренном открытом ПО, которое бы способствовало совместной работе исследователей над новыми инструментами.

Основная сила ОПО в том, что оно дает возможность открытых исследовательских коллабораций, позволяя новым идеям и технологиям распространяться быстрее. В этом модуле будут представлены все необходимые инструменты, которые позволят превратить ПО в ПО с открытым доступом и возможностью многократного пользования.

<img src="https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/images/open_research_software_open_source.png?raw=true" width="800" />

<p align="center"><i>Автор изображения - Патрик Хоктенбах (CC0 1.0 Universal)</i></p>

<br/>

### **Чему научит этот модуль**:

1. Вы узнаетие о характеристиках открытого ПО; поймете плюсы и минусы открытого ПО с **этической, юридической, экономической и исследовательской точек зрения**. Вы также узнаете требования к качеству открытого ПО.

2. Вы научитесь трансформировать код для личного пользования в код, доступный для других пользователей.

3. Вы научитесь использовать ПО/программы, работающие с открытым контентом и позволяющие делать это в команде с другими разработчиками. 

<br/>

## Что такое Открытое Программное Обеспечение (ОПО) <a name="Об_ОПО"></a>

Практически все современные научно-исследовательские процессы опираются на ряд программных инструментов. Они могут обеспечивать работу с разными наборами данных, параметров и способами анализа (наука о данных), либо работу со входными данными, к которым применяются разные модели и методы с целью прогнозирования результата (вычислительные науки). Отличие открытого ПО от обычного в том, что программный код открытого ПО лицензирован таким образом, чтобы его можно было просматривать, модифицировать и распространять. Подобное лицензирование позволяет сделать открытое ПО бесплатным (но это, тем не менее, не то же самое, что бесплатные программы). Возможность многократного пользования ОПО для анализа, проведения симуляций и визуализации данных делает его более гибким и простым в сравнении с частным ПО. На самом деле, довольно часто мы, сами того не зная, используем ОПО в нашем рабочем процессе.     

ОПО входит в более широкую категорию Open Science, поскольку оно позволяет создать исследовательскую среду, включая ПО, доступной и "многоразовой". ОПО создает все необходимое для удобства работы ([Jiménez et al., 2018](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Jim%C3%A9nez%20et%20al.%2C%202018.pdf)) и воспроизводимости исследований, наряду с возможностью обмена данных ([Stodden, 2010](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Stodden%2C%202010.pdf)).

В некоторых случаях, предоставление исходного программного кода - необходимое условие публикации научной работы ([Shamir et al., 2013](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Shamir%20et%20al.%2C%202013.pdf)). Считается, что это также добавляет значимости проделанному исследованию ([Vandwalle, 2012](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Vandewalle%2C%202012.pdf)).

Вот некоторые из преимуществ для разработчиков:

- Лояльность и поддержка со стороны других разработчиков;

- Более низкие затраты на обслуживание и маркетинг;

- Больше брендинга для услуг и продуктов;

- Производство ПО высокого качества по более низкой стоимости;

- Гибкость и быстрое внедрение инновационных идей;

- Кастомизация и модульная интеграция;

- Повышенные надежность и независимость; и

- Доступность для каждого.

Основные преимущества для исследователей и пользователей - это **сниженные затраты**, **прозрачность**, **более высокие защита и стабильность**, **отсутствие закрытого режима с ограниченным контролем** и **более высокое качество**. Более того, распространение ОПО может конвертироваться в признательность со стороны других исследователей, например, посредством цитирования вашей работы [(Smith et al., 2016)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Smith%20et%20al.%2C%202016.pdf).
	
Наиболее часто используемыми образцами ОПО служат веб-браузер [Mozilla Firefox](https://www.mozilla.org/en-US/firefox/) и офисный пакет [LibreOffice](https://www.libreoffice.org/). LibreOffice схож с пакетом Microsoft Office, включая работу с текстом (Word), таблицами (Excel) и презентациями (PowerPoint), являясь при этом полностью бесплатным и открытым.

Некоторые считают движение ОПО противодействием неолиберализму и приватизации, которое осуществляется посредством несоблюдения норм в области конструирования и повторного использования информации, а также потенциальной трансформации современного капитализма через создание изобильно доступного ПО с минимальными усилиями. Чтобы узнать об этом аспекте по-подробнее, почитайте статью Панайоты Георгополу [The free/open source software movement: Resistance or change?](http://www.redalyc.org/html/742/74212712006/)

<br/>

## Принципы ОПО <a name="Принципы"></a>

Один из пионеров движения - организация [Open Source Initiative](https://opensource.org/), дает следующее определение [ОПО](https://en.wikipedia.org/wiki/The_Open_Source_Definition#Definition):

*Без паники, это не нужно заучивать, будет здорово, если у вас сформируется понимание того, где взяло свое развитие ОПО.*

- **Свободная редистрибуция**: Лицензия не должна ограничивать продажу/распространение ОПО. Это так же распространяется на ПО, которое является частью программного продукта, куда входят программы, созданные независимо друг от друга. Лизенция не должна взимать денежную плату.

- **Программный код**: Программа должна включать в себя исходный программный код. Распространение ОПО должно быть возможным как в формате исходного кода, так и в собранном (готовом) виде. Отсутствующий исходный код должен быть сопровожден справкой о том, где и как его можно получить (например, посредством бесплатного скачивания из интернета). Исходный код должен быть предпочтительным видом, с помощью которого можно модифицировать программу. Недопустимы преднамеренно запутанный исходный кода, так же как и незавершенная работа (например, выходные данные препроцессора/переводчика).

- **Изменения в ПО**: Лицензия должна позволять модификации и производные работы. Эти модификации должны иметь право распространяться на тех же условиях, что и лицензия оригинального ПО.

- **Целостность авторского исходного кода**: Лицензия может ограничивать распространение модифицированного кода только в том случае, если лицензия позволяет распространение patch-файла (файла исправлений), содержащим исходник кода. Лицензия должна давать разрешение на распространение ПО, построенного на основе модицифированного исходного кода. Лицензия может требовать производные работы с целью получения названия или версии, отличного от оригинального ПО.

- **Дискриминация недопустима**: Лицензия не должна накладывать какие-либо ограничения на кого-либо.

- **Ограничение сферы использования недопустимо**: Лицензия не должна накладывать ограничения на сферу использования. Например, не должно существовать ограничений на использование ОПО только в бизнесе или генетических исследованиях. 

- **Распространение лицензии**: Права пользования программой должны распространяться на всех пользователей без необходимости дополнительных лицензий.

- **Лицензия не должна быть специфичной для продукта**: Права, привязанные к программе не должны зависеть от того, входит ли программа в определенный дистрибутив ПО. Если программа извлечена из дистрибутива и распространяется под регуляцией этой лицензии, все, среди кого распространяется эта программа должны иметь такие же права как те, кто работает с оригинальным дистрибутивом ПО.

- **Лицензия не должна ограничивать другие ПО**: Лицензия не должна ограничивать ПО, прилагающееся к лицензируемому ПО. Например, лицензия не должна настаивать на том, чтобы все программы, которые распространяются через один ресурс, должны быть открытыми.

- **Лицензия должна быть независима от технологий**: Предоставление лицензии не должно основываться на какой-либо технологии или интерфейсе.

Все перечисленное может быть сложным для запоминания, но основной вывод следующий: *создавать ПО максимально открытым для доступа и многократного использования в будущем*. 

<br/>

## Чеклист Open Source

Существует несколько платформ и инструментов, которые поддерживают ОПО и совместную работу. В книге [Open Science Training Handbook](https://open-science-training-handbook.gitbook.io/book/) можно найти чек-лист для оценки "открытости" существующего программного обеспечения. Чек-лист основывается на определении Open Source, приведенном выше:

- [ ] Доступно ли ПО для загрузки и установки?

- [ ] Одинаково ли легко ПО устанавливается на разных платформах?

- [ ] Есть ли какие-либо условия использования ПО?

- [ ] Доступен ли исходный программный код?

- [ ] Находится ли история модификации исходного кода в публичном доступе?

- [ ] Надлежащим ли образом описаны требования ПО к аппаратному и программному обеспечению? Насколько большие усилия требуются, чтобы удовлетворить этим требованиям?

Проверили, проверили, проверили, готово! 

<br/>

## Сообщество Open Source и его управление <a name="ОПО_сообщество"></a>

Существует два лагеря в сфере свободного ПО: **Движение за свободное ПО** и **ОПО движение**. Оба лагеря придерживаются разных идеологий в плане пользовательских прав и пользования ПО. Аббревиатура 'FLOSS' зачастую используется для примирения этих двух направлений. Она расшифровывается как "Свободное и открытое программное обеспечение", где "Свободное" происходит от французско-испанского слова Libre.   

Основное отличие ОПО от свободного - возможность многократного использования. Термин "Свободное и открытое ПО" включает в себя ПО, которое одновременно и свободное, и открытое. Хорошим примером "Свободного и открытого ПО" (FOSS) является операционная система [Ubuntu Linux](https://www.ubuntu.com/).

Большое различие между свободным и открытым ПО заключается в том, что обновления для свободного ПО должны выпускаться под той же лицензией, что и оригинальная программа, тогда как обновления для открытого ПО имеют право выходить под новой лицензией. FOSS, между тем, берет лучшее от двух лагерей.  

Эти определения теперь широко используются одновременно и международными правительствами, так и крупными компаниями [Mozilla Foundation](https://www.mozilla.org/en-US/foundation/) и [Wikimedia Foundation](https://wikimediafoundation.org/wiki/Home). Крупнейшими оргиназациями в сфере FLOSS (Свободное и открытое ПО) являются, например, [Software Sustainability Institute](https://www.software.ac.uk/), которые не так давно выпустили [Пособие по ОПО для исследователей](https://softwaresaved.github.io/software-deposit-guidance/).

### Для индивидуальных проектов

Обычный open source проект включает в себя следующие роли:

- **Автор**: Человек, создавший проект
- **Владелец**: Человек/команда, административно владеющая организацией/репозиторием
- **Специалисты по сопровождению ПО**: Люди, ответственные за общее видение и управление организационными аспектами проекта. Это могут быть те же люди, что и Автор/Владелец.
- **Соавтор**: Пользователь, который внес свой вклад в проект.
- **Члены сообщества**: Пользователи. Они могут быть активными участниками дискуссии и выражать свое мнение касательно улучшений будущих проектов. 

Как правило, все вышеописанные роли прописаны в файле `README`, в файле "Соавторы" или в отдельной вкладке, посвященной команде проекта. 

<br/>

## Платформы и инструменты ОПО <a name="Платформы"></a>

Виртуальные операционные среды и машины набирают популярность как мощные исследовательские инструменты. Многие из них построены на базе открытого ПО, например, операционные системы, языки программирования, принципы обработки данных. Среди популярных сервисов [Google Cloud](https://cloud.google.com/compute/) и [Amazon Web Services](https://aws.amazon.com/), которые предоставляют возможность хранения и доставки данных, наряду с вычислительными мощностями. Еще один пример - [InsideDNA](https://insidedna.me/) - это вычислительная платформа для исследований в области биоинформатики, геномики и науках о живых существах.  

Как упоминалось [выше](#Об_ОПО), LibreOffice представляет собой открытую альтернативу пакету Microsoft Office. LibreOffice и Microsoft Office различаются лишь в разных встроенных форматах документов. Для работы с цитированием [Zotero](https://www.zotero.org/) является самой популярной открытой альтернативой частным платформам Mendeley и EndNote.   

[Zotero](https://www.zotero.org/) использует BibTeX формат (произносится как биб-тех), работающий на базе LaTeX (лэй-тех). Плагины, используемые в Zotero позволяют максимально упростить процесс цитирования. Используя Zotero вместе с другим ПО, как, например, LibreOffice, можно сделать свой рабочий процесс полностью открытым. 

### GitHub <a name="GitHub"></a>

> Знали ли вы, что этот проект это результат совместной работы на платформе [GitHub](https://github.com/OpenScienceMOOC/)?

[GitHub](https://github.com/) - это веб хостинг для программного и не программного контента (не-программный часто называют 'notebooks'). Гитхаб предоставляет функции контроля текущей версии, управления проектом, возможностью мониторинга и хранения данных. ГитХаб построен на основе [Git](https://git-scm.com/), который позволяет  пользователям удаленно поддерживать ПО в работоспособном состоянии, сотрудничать в работе над ПО и проектами, не связанными с программным обеспечением. 

Контроль текущей версии - это запечатление файлов в репозитории с целью отслеживания всех внесенных изменений. Контроль версии позволяет знать, какие изменения были внесены, а также когда и кем они были сделаны. В случае, когда несколько людей работают над файлом, пересекающиеся или противоречащие друг другу изменения должны быть идентифицированы и команда должна определиться с выбором конечного изменения, чтобы двигаться дальше. Такой процесс совместной работы гораздо более отлаженный, чем ручное сохранение в процессе работы над проектом. Это также позволяет избавиться от неизбежной путаницы в документах, в названии которых указаны разные версии файла...

<p align="center"><img src="https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/images/xkcd.png?raw=true" width="200" /></p>

<p align="center"><i>GitHub позволяет избежать пагубной привычки неоптимальных названий файлов (источник: XKCD)</i></p>

<br/>

Одна из самых полезных функций GitHub это [баг-трекер](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/issues), используемый в организации разработки ОПО. По ссылке выше вы можете найти баг-трекер, который использовался в процессе разработке этого модуля! Если у вас есть мысли о том, как можно улучшить модуль (или просто комментарии), смело ступайте туда.  

Другие схожие хостинг-сервисы включают в себя [BitBucket](https://bitbucket.org/), [GitLab](https://about.gitlab.com/), и [Launchpad](https://launchpad.net/). Если присоединение GitHub к Microsoft смущает вас, BitBucket, GitLab и Launchpad - прекрасные альтернативы.

Тем не менее, мы знаем, что на GitHub довольно крутая кривая обучения (learning curve). По этой причине первое практическое задание покажет вам, как установить свой первый пректный репозиторий именно там.

**[Перейти к заданию 1: Создание вашего первого GitHub репозитория](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/Task_1.md)**

<br/>

## ОПО для исследований <a name="Исследования"></a>

Развитие и использование ОПО становится стандартной практикой, особенно в области научных исследований. На то есть несколько причин, помимо тех, которые относятся к общему признанию ОПО. Например: 

- Все чаще алгоритмы, встроенные в аналитическое ПО, становятся важной частью методологии, описываемой в научных публикациях. Сейчас наличие алгоритмов, закрытых для посторонних, становится проблемой в процессе предварительного обзора статьи, подаваемой в научный журнал. 

- Научные коллаборации все чаще охватывает несколько учреждений и рассредоточенные исследовательские команды, где секретность и командная иерархия не поддерживаются в том виде, в котором должны в разработке закрытого ПО.

- Часто вычислительный анализ осуществляется в виртуальной среде (институциональные, национальные или международные "облака") и хранится на многопльзовательских серверах. Коммерческое (закрытое) программное обеспечение с закрытым исходным кодом часто запрещает подобные вещи.

- Разработка ОПО зачастую лежит на плечах волонтеров. Это - огромное преимущество во время недостаточности финансирования исследований.
	
По этим и другим причинам, Open Source программы часто используются в научных исследованиях. Например, в областях, где исследователи одновременно и разработчики-любители, для статистического анализа чаще всего используется программа [R](https://www.r-project.org/), которая практически полностью заменила коммерческое ПО SPSS или JMP во многих областях. В таких областях, как биоинформатика, куда входит обработка файлов входных данных ДНК секвенирования, язык программирования [Python](https://www.python.org/) и библиотеки по типу [biopython](http://biopython.org)) становятся важнейшими инструментами для многих исследователей.

<p align="center"><img src="https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/images/python.png?raw=true" width="400" /></p>

<p align="center"><i>Python</i></p>

<br/>

R и Python - это, по сути, программное обеспечение для создания программного обеспечения. Хотя программирование и становится все более частым занятием среди исследователей, это не значит, что *каждый* исследователь программирует. Одним шагом в сторону от программирования является объединение входных и выходных данных аналитических инструментов в более обширный рабочий процесс. Например, в геномике рабочий процесс чаще всего устроен следующим образом: все начинается с чтения последовательностей с высокой пропускной способностью и затем 1) базовый контроль качества; 2) сопоставление с эталонным геномом; 3) идентификация мест, где новые данные не соответствуют эталонным. Описанный процесс - не разработка открытого ПО как таковая, но он включает в себя использование и разработку ОПО продуктов (например, скрипты в Linux), на которые распространяются принципы, описанные в этом модуле.  

<p align="center"><img src="https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/images/r.png?raw=true" width="200" /></p>

<p align="center"><i>R</i></p>

<br/>

И, наконец, внедрение ОПО в исследовательской деятельности объясняется теми же причинами, по которым ОПО становится на широкую ногу в обществе - оно дешевле. Например, пользователи или организации могут принять решение перейти с Microsoft Office на LibreOffice как инструмент для работы с текстом, кодом или таблицами, потому что LibreOffice свободен (так же как и [**'бесплатное пиво'**](https://www.youtube.com/watch?v=dQw4w9WgXcQ) и 'свободная речь'). Схожим образом, решение сменить ArcGIS на [QGIS](https://www.qgis.org/en/site/) для анализа географической информации может быть оправдано соображениями сохранения бюджета.

## Первые шаги в ОПО - FAQ <a name="FAQ"></a>

**Я использую X[например, Matlab,STATA,Excel] и я хочу перейти на что-то более открытое. Какие мои действия?**

Даже если вы используете частное программное обеспечение, вы можете делиться исходным кодом/документацией и так далее. *Первый шаг это делиться всем, чем вы можете*.

**Отлично! Я могу выгрузить данные в репозиторий GitHub.**

Если этого на данный момент достаточно - отлично! Если нет, то для большинства коммерческого ПО существуют Open Source аналоги:

| Закрытое ПО | Открытое ПО |
| --- | --- |
| Matlab | Python, Julia |
| STATA/SPSS | R |
| MS Office | LibreOffice |
| Mathematica | JupyterLab |
| Попрактиковаться в навыках [Pull Request -PR-](https://help.github.com/articles/about-pull-requests/) Skills ... | ... путем добавления вашего собственного примера [сюда](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/MAIN.md) |

**Супер! Но если я перехожу на открытую платформу, это значит трата времени на изучение новых программ, отсутствие службы поддержки и борьба с багами.**

Это хорошее замечание, но это не всегда так. Лучше всего будет найти кого-нибудь, кто уже перешел на открытое ПО и узнать об их опыте. Разумеется, можно и погуглить: какие-то открытые аналоги гораздо лучше закрытых программ, некоторые - пока что нет, поэтому, выбор ОПО стоит делать внимательно.

## Создание ПО для многократного использования <a name="Re-use"></a>

Вы в будущем - это тот, кому, вероятнее всего, пригодится ПО, которое вы создаете прямо сейчас. Делиться сделанным всегда лучше, чем не делиться, но вместе с тем, можно упростить жизнь и себе с помощью использования подходящей документации. Документация включает в себя несколько компонентов, среди которых комментарии и аннотации в коде, из которых можно узнать причину, по которой каждое конкретное действие выполняется, нежели конечную цель действия.

Один из важнейших аспектов в этом контексте - документ `README`, который сопровождает практически каждый ОПО проект, а порой их даже больше, чем один. Хорошей практикой в этом направлении может стать включение файла документации (`README`) в каждую директорию. В `README` должны быть перечислены все файлы, содержание и цель директории. Чаще всего файл `README` представляет из себя обычный текст или маркдаун файл (как и все файлы для МООК), где описывается процесс установки и запуска ПО, системные требования, туториалы или другие примеры.

> **Знали ли вы...** Термин `README` иногда шутливо приписывают известной сцене из "Алисы В Стране Чудес" Льюиса Кэрролла, в которой Алиса сталкивается с волшебными закусками с надписями "Съешь меня" и "Выпей меня". Звучит убедительно!

Наша цель - дать информацию с целью увеличить многократность использования и воспроизводимость вычислительной среды так, чтобы человек без знаний проекта мог получить доступ и использовать это ОПО ([Sandve et al., 2013](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Sandve%20et%20al.%2C%202013.PDF)). Снижая уровень сложности на входе, вы увеличиваете шансы пользователей на использование вашей работы, а это - основная цель ОПО ([Ince et al., 2012](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Ince%20et%20al.%2C%202012.pdf)).
	
Подход, упрощающий жизнь с точки зрения повторного использования ПО в будущем - "контейнерная" технология. Контейнеры - это что-то вроде экосистемы, застывшей во времени, в которой код, данные, любые другие компоненты законсервированы, упакованы и сохранены в рабочей версии. Это значит, что любой человек в будущем может запустить анализ. Контейнеры хороши для многократного пользования, но многие детали могут быть скрыты в исходном коде и его зависимостей (dependencies), что может отрицательно сказаться на понимании ПО другими людьми. Частый пример реализации "контейнерной" техноголии в исследованиях - [Rocker](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Boettiger%20and%20Eddelbuettel%2C%202017.pdf) (ПО Docker для языка программирования R), [Binder](https://mybinder.readthedocs.io/en/latest/), и [Code Ocean](https://codeocean.com/).

**Устойчивое ПО = хорошее ПО.**

<br/>

## 10 простых правил для воспроизводимых вычислительных исследований

10 правил воспроизводимости вычислительных исследований были придуманы [Sandve et al., (2013)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Sandve%20et%20al.%2C%202013.PDF). Вот и они:

1. Для каждого индивидуального результата следить за тем, как он был получен.
2. Избегать ручной работы с данными.
3. Архивировать точные версии всех внешних программ, которые используются в работе.
4. Контролировать версии всех пользовательских скриптов.
5. Регистрировать все промежуточные результаты, по возможности в стандартизированной форме.
6. Для анализа, предполагающего случайные результаты, указывать случайные начальные значения (random seeds).
7. Всегда сохранять необработанные данные в каждом графике.
8. Создавая иерархический результат, позволять доступ к разноуровневой информации.
9. Связывать словесные утверждения (легенды) с соответствующими результатами.
10. Предоставлять открытый доступ к скриптам, прогонам и результатам.

<p align="center"><img src="https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/images/simple_rules.png?raw=true" width="800" /></p>

<p align="center"><i>Инфографика адаптирована из Sandve et al., (2013). Её можно скачивать и печатать, чтобы всегда иметь под рукой!</i></p>

<br/>

Эти шаги помогут вам в работе над [**первым**](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/Task_1.md) и [**вторым**](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/Task_2.md) заданиями.

<br/>

## Лицензирование ОПО <a name="Лицензирование"></a>

ОПО лицензия создана специально для того, чтобы детально очертить правовые условия распространения и многократного использования ПО. Как было сказано [выше](#Об_ОПО), наличие соответствующего лицензирования отличает публично распространяемое ПО от открытого ПО. Например, широко распространенная программа [MATLAB](https://www.mathworks.com/products/matlab.html) это закрытое ПО, тогда как [Octave](https://www.gnu.org/software/octave/) - альтернативный язык программирования с открытой лицензией.

На данный момент существует более 1400 уникальных Open Source лицензий. Различия в правовых последствиях разных лицензий несколько усложняет ситуацию.

Список наиболее часто используемых лицензий:

- [Berkeley Software Distribution ("BSD")](https://en.wikipedia.org/wiki/BSD_licenses),
- [Apache](https://www.apache.org/licenses/LICENSE-2.0),
- [MIT-style (Massachusetts Institute of Technology)](https://opensource.org/licenses/MIT), или
- [GNU General Public License ("GPL")](https://www.gnu.org/licenses/gpl-3.0.en.html).

Вам не нужно знать все юридические тонкости, но полезным будет просто знать, что информацию о специфике лицензий можно найти в открытом доступе.

Существует два способа получения лицензии на участие в проекте:

1. *Явный*: когда индивидуальный вклад в проект имеет четко указанную лицензию, независимую от основного проекта; или
2. *Неявный*: когда индивидуальный вклад покрывается лицензией основного проекта.

К счастью, выбор Open Source лицензии сравнительно простой благодаря простому в использовании инструменту [Choose A License](https://choosealicense.com/). Каждая из лицензий позволяет другим пользователям использовать, копировать, распространять и использовать вашу работу как фундамент для своего проекта. При этом другие пользователи знают, что изначальный автор (например, вы) был указан и признан. Ключевым моментом является выбор подходящей лицензии для вашей работы в зависимости от того, какие действия с вашим продуктом вы считаете допустимым со стороны других пользователей.

<br/>

## Цитирование ПО <a name="Цитирование"></a>

Цитирование это один из важнейших способов взаимодействия в академической среде, который формирует систему ссылок и метрики. Как правило, цитирование осуществляется с помощью уникального идентификатора [Digital Object Identifiers](https://en.wikipedia.org/wiki/Digital_object_identifier) (DOI). DOI - постоянный идентификатор, встроенный в [Handle System](https://en.wikipedia.org/wiki/Handle_System). Существуют общие стандарты DOI в зависимости от изначальной цели как например, для идентифицирования академической информации. Подобные идентификаторы критически важны для отслеживания генеалогии и происхождения исследования, для воспроизводимости результатов и для выражения признательности создателям ПО. Важно отметить, что ПО должно рассматриваться как законный результат научных исследований. Цитирование ПО, таким образом, становится все более распространенным способом подтвердить этот факт.

В 2016 году в составе FORCE11 Software Citation Working Group [Смит и соавторы](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Smith%20et%20al.%2C%202016.pdf) опубликовали статью о принципах цитирования ПО. Помимо желания состалься на используемое ПО других исследователей, стоит уделить время тому, чтобы и свое ОПО сделать простым с точки зрения цитирования. Цитирование ПО должно включать как минимум следующие данные:

- Имя автора/авторов,
- Название ПО,
- Версия (номер), и
- Уникальный идентификатор (DOI или URL).

Шесть принципов цитирования от Смита и соавторов (2016) можно найти по ссылке(https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Smith%20et%20al.%2C%202016.pdf):

* **Важность**: ПО должно рассматриваться как законный и цитируемый результат научной работы. Цитирование ПО - это настолько же важно, как и упоминание/цитирование таких результатов исследований, как данные и другие научные публикации; ссылки на ПО должны быть включены в метаданные цитирующей работы, например, в список литературы статьи в журнале. Ссылки на ПО не должны находиться в отдельном месте или не быть освещенными вовсе. Они должны находиться в одном ряду вместе со ссылками на литературу, то есть, авторы ПО должны быть упомянуты так же, как и авторы книг и публикаций. 

* **Упоминание и ссылки на источники**: Ссылки на ПО должны способствовать тому, чтобы все участники, вносящие вклад в разработку ПО, получали научное и юридическое признание. Нужно понимать, что единый стиль или механизм определения авторства может быть применим не ко всему программному обеспечению.

* **Уникальный идентификатор**: Ссылки на ПО должны включать метод идентификации, который является машинным, глобально уникальным, функционально совместимым и признанным в, как минимум, среде экспертов в этой области и, желательно, широком кругу исследователей. 

* **Живучесть**: Уникальные идентификаторы и метеданные, описывающие ПО и его расположение должны быть живучими, даже более живучими, чем само описываемое ПО.

* **Доступность**: Ссылки на ПО должны способствовать доступу к ПО и к связанным с ним метаданным, документации, данным и другим материалам, необходимым для людей и компьютеров, чтобы сделать пользование ПО информированным.

* **Специфичность**: Ссылки на ПО должны способствовать идентификации и доступу к конкретной версии ПО, которое было использовано. Идентификаторы ПО должны быть настолько специфичными, насколько это необходимо: номер версии, номер пересмотра/модификации или платформы.

Заметка: Для более подробной инструкции о том, как сделать ПО цитируемым, см. секцию [**Работа с GitHub и Zenodo**](#GitHub_Zenodo) ниже и [**Задание 2: Linking GitHub and Zenodo**](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/Task_2.md).

<br/>

## Работа с GitHub и Zenodo <a name="GitHub_Zenodo"></a>

[GitHub](#GitHub) это популярный инструмент для управления проектами, хранения данных и контроля версии. Сам по себе GitHub не является открытым ПО. Тем не менее, инструмент, на основе которого был создан гитхаб - да. Гит (Git) был создан с целью управлять исходным кодом файлов и их обновлениями для ПО-проектов. Сейчас это могут быть не ПО-проекты. Взять, например, этот [МООК](https://github.com/OpenScienceMOOC/)!

Тем не менее, изучение Гитхаба это только первый шаг. В одинаковой степени важно сделать его устойчивым и доступным для многократного пользования, с чем помогает Цифровой Идентификатор Объекта (DOI). Самый простой способ создания цифрового идентификатора, это программа [Zenodo](https://zenodo.org/) - открытый и свободный мульти-дисциплинарный репозиторий, созданный OpenAIRE и CERN. [Zenodo](https://zenodo.org/) позволяет присваивать DOI идентификаторы Гитхаб репозиториям. Этот гайд [GitHub Guide](https://guides.github.com/activities/citable-code/) подробно рассказывает о том, как связывать Гитхаб репозитории напрямую через Zenodo так, что когда разработчики официально выпускают ПО, Zenodo создает и архивирует именно эту версию ПО.

Единственное, что еще можно добавить о Zenodo: программа **бесплатна**. Плюс, помимо Гитхаба вы можете пользоваться другими репозиториями, например, [DataCite DOI Fabrica](https://doi.datacite.org/) или ваш институциональный репозиторий вроде [Caltech's](https://www.library.caltech.edu/news/enhanced-software-preservation-now-available-caltechdata).

Многие исследователи боятся делиться кодом, который пока что не закончен, может содержать ошибки или просто неидеален. Тем не менее, публикация "сырого" кода это распространенная практика в сообществе ОПО. Шеринг кода позволяет другим пользователям использовать и улучшать его, также это позволяет глубже включиться в исследования, связанные с ним. Это один из основополагающих аспектов коллективной работы, возможно, лучше всего иллюстрируемый традиционным процессом рецезнирования исследовательских работ. 

Задание 2 покажет вам процесс связывания Гитхаб репозитория с Zenodo для последующей архивации.

> **Знали ли вы...** Что все содержание этого курса доступно в [Zenodo](https://zenodo.org/communities/open-science-mooc/)?

**[Перейти к заданию 2: Linking GitHub and Zenodo](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/Task_2.md)**

<br/>

## Совместная работа на основе Open Source <a name="Коллаборации"></a>

Зачастую ОПО разрабатывается публично, децентрализовано и совместно несколькими разработчиками. Цель этого процесса - увеличить разнообразие и масштаб проекта и его дизайна, чтобы сделать его более устойчивым и полезным. Подобный подход подобен модели "базара" Эрика Реймонда, одного из первых сторонников ОПО. Один из основных принципов - **взаимное производство**, которое полагается на само-организованное сообщество, которое регулирует развитие и координацию контента по направлению к конечной цели.

ОПО проекты в значительной степени зависят от работы волонтеров, что часто влечет за собой постоянный приток новичков ([Steinmacher et al., 2014](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Steinmacher%20et%20al.%2C%202014.pdf)). Создание правильной атмосферы и дружелюбной среды критически важны для успешного сотрудничества над ОПО.

<br/>

## Что дальше <a name="Продолжение_ОПО"></a>

Надеемся, что мы сумели показать ПО как важнейший краеугольный камень современной науки и то, какую важную роль в ней играет ОПО.

**Результаты обучения** из этой главы следующие:

1. Вы сможете определять характеристики ОПО и некоторые этические, юридические, экономические и исследовательские аргументы за и против.
2. Основываясь на стандартах сообщества, вы сможете описать требования к качеству распространения и повторного использования открытого кода. 
3. Вы сможете использовать разные исследоватльские инструменты, которые работают с ОПО.
4. Вы сможете трансформировать код, созданный для личных целей, в код, который доступен для пользования другими людьми.
5. Разработчики ПО смогут сделать свое ПО доступным для цитирования, в то время как пользователи ПО будут знать, как правильно на него ссылаться.
	
<br/>

**Бонусное задание**

Если вы закончили [Задание 1](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/Task_1.md) и [Задание 2](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/Task_2.md), у нас есть для вас **бонусное задание**, если вы хотите улучшить свои навыки еще больше. [Задание 3](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/Task_3.md) расскажет, как можно интегрировать Гит в свой рабочий процесс на примере интеграции с R Studio. За третье задание стоит браться после того, как вы управились с первым и вторым.

Тем не менее, Ваше Open Source путешествие на этом не заканчивается! Это только начало и впереди вас ждет масса потрясающих ресурсов для образования в этой области:

* Если вы поймали особенное вдохновение от всего написанного здесь, вы можете подписать манифест [Science Code Manifesto](http://sciencecodemanifesto.org/), который основывается на пяти принципах кода, авторского права, цитирования, признательности и курирования.

* Для разработки и запуска своего собственного проекта, [Open Source Guides](https://opensource.guide/) поможет вам своими практическими гайдами и функциями для этих целей.

* Для более детального знакомства с рабочими процессами на базе ОПО, гайд [Open Science, Open Data, Open Source](https://pfern.github.io/OSODOS/gitbook/) авторства Педро Фернандеса и Рутгера Воса - один из лучших онлайн-источников.

* Еще существуют более формальные площадки для публикаций, связанных с ПО, включая [The Journal of Open Research Software](https://openresearchsoftware.metajnl.com/) и [The Journal of Open Source Software](https://joss.theoj.org/).  Полный список доступен [по ссылке](https://www.software.ac.uk/which-journals-should-i-publish-my-software).

* На площадке [PLOS Open Source Toolkit](https://channels.plos.org/open-source-toolkit) вы можете найти глобальный форум для исследователей в области аппаратного и программного обеспечения в Open Source. 

* [NumFOCUS](http://www.numfocus.org) - некоммерческая организация, которая поддерживает и продвигает инновационноое ОПО мирового уровня. Вот некоторые из проектов, которые поддерживаются NumFOCUS:

* Инициативы [IPython](http://ipython.org) и [Jupyter Notebook](https://jupyter.org).

* [rOpenSci](http://ropensci.org), который продвигает открытую среду R для прозрачности и воспроизводимости исследований.
  

* Побольше попрактиковаться в ОПО можно еще и на регулярных воркшопах от [Software Carpentry](https://software-carpentry.org/) ([Wilson et al., 2017](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Wilson%20et%20al.%2C%202017.pdf)).

<br/>

### Что почитать <a name="Литература"></a>

*Эти источники подходят для самого начала вашего пути в Open Source. Здесь вы найдете самые полезные **общие** обзоры по ОПО. С этого же можно начать, если вы ищете что-то более узконаправленное в вашей конкретной области.*

* The Future of Research in Free/Open Source Software Development [(Scacchi, 2010)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Scacchi%2C%202010.pdf).

* The Scientific Method in Practice: Reproducibility in the Computational Sciences [(Stodden, 2010)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Stodden%2C%202010.pdf).

* The case for open computer programs [(Ince et al., 2012)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Ince%20et%20al.%2C%202012.pdf).

* Current issues and research trends on open-source software communities [(Martinez-Torres and Diaz-Fernandez, 2013)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Martinez-Torres%20and%20Diaz-Fernandez%2C%202013.pdf).

* Ten simple rules for reproducible computational research [(Sandve et al., 2013)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Sandve%20et%20al.%2C%202013.PDF).

* A systematic literature review on the barriers faced by newcomers to open source software projects [(Steinmacher et al., 2014)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Steinmacher%20et%20al.%2C%202014.pdf).

* Knowledge sharing in open source software communities: motivations and management [(Iskoujina and Roberts, 2015)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Iskoujina%20and%20Roberts%2C%202015.pdf).

* Software citation principles [(Smith et al., 2016)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Smith%20et%20al.%2C%202016.pdf).

* An introduction to Rocker: Docker containers for R [(Boettiger and Eddelbuettel, 2017)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Boettiger%20and%20Eddelbuettel%2C%202017.pdf).

* Good enough practices in scientific computing [(Wilson et al., 2017)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Wilson%20et%20al.%2C%202017.pdf).

* Four simple recommendations to encourage best practices in research software [(Jiménez et al., 2017)](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/Reading%20Material_Open%20Source%20and%20Open%20Research%20Software/Jim%C3%A9nez%20et%20al.%2C%202018.pdf).

<br/>

### Команда разработчиков <a name="Команда"></a>

- [Alex Morley](https://twitter.com/alex__morley), Open Sourceror, University of Oxford, UK.
- [Kevin Moerman](https://twitter.com/KMMoerman), Open Sourceror, MIT, USA.
- [Tania Allard](https://twitter.com/ixek), Open Sourceress, Data Enchantress, University of Leeds, UK.
- [Simon Worthington](https://twitter.com/mrchristian99), Book Liberationist, TIB, Germany.
- [Paola Masuzzo](https://twitter.com/pcmasuzzo), Open Source Batman, Italy.
- [Ivo Grigorov](https://twitter.com/OAforClimate), Open Source Robin, Denmark.
- [Rutger Vos](https://twitter.com/rvosa), Open Sourceror, Naturalis Biodiversity Center, the Netherlands.
- [Julien Colomb](https://twitter.com/j_colomb), Open Ninja, Berlin.
- [Jon Tennant](https://twitter.com/protohedgehog), Dinosaur Whisperer.

**Есть советы по улучшению содержания?**

Настало время чтобы попробовать свои новенькие навыки в GitHub! Вся разработка контента происходит [здесь](https://github.com/OpenScienceMOOC/Module-5-Open-Research-Software-and-Open-Source/blob/master/content_development/MAIN.md). Если у вас есть мысли, предложения о том, как мы можем улучшить проект, дизайн или что-угодно другое - вносите ваши комментарии и изменения по ссылке выше, и они станут частью этого МООКа после того, как модератор верифицирует ваши комментарии.

[![CC0 Public Domain Dedication](https://img.shields.io/badge/License-CC0%201.0-lightgrey.svg)](https://creativecommons.org/publicdomain/zero/1.0/)
